unit u_comp_TScanner;
{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright Andr? Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestro 2013 GPL)           }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}


interface

uses
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     u_common_TWAIN, extctrls, graphicEx;

type
     TScanner = class(TComponent)
     private
          fTempPathName: string;
          hdib, testdib: hbitmap;
          w, h: integer;
          n: Integer;
          fImage: TImage;
          fResultImageFileName: string;

     public
          property ResultImageFileName: string read fResultImageFileName write fResultImageFileName;

          constructor Create(AOwner: TComponent); override;
          function Execute: boolean;

     published
          property TempPathName: string read fTempPathName write fTempPathName;

     end;

procedure Register;
procedure CallbackFxn(CurDib: THandle; index: Integer); stdcall; forward;

implementation

uses
     ComObj;

procedure Register;
begin
     RegisterComponents('EvaluatePak', [TScanner]);
end;

{ TScanner }

constructor TScanner.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);

     hDib := 0;
     w := 0; h := 0;
     testDib := 0;

     fImage := nil;

     TWAIN_RegisterCallback(CallbackFxn);
end;

function TScanner.Execute: boolean;
var
     tempImageFileName: string;
     tempImage: TImage;
begin
     result := false;


     if TWAIN_SelectImageSource(0) <> 0 then
     begin
          tempImageFileName := CreateClassID + '.bmp';
          tempImage := TImage.create(self);
          try
               //showMessage(inttostr(k));
               hdib := TWAIN_AcquireNative(0, 0);
               n := TWAIN_GetNumDibs;
               if n >= 1 then
               begin
                    TestDib := TWAIN_GetDib(0);
                    CopyDibIntoImage(TestDib, tempImage);
                    TWAIN_FreeNative(TestDib);
                    TestDib := 0;

                    //Sauvegarde de l'image
                    try
                         tempImage.Picture.SaveToFile(fTempPathName + tempImageFileName);
                         result := true;
                         fResultImageFileName := fTempPathName + tempImageFileName;
                    except
                    end;
               end;
          finally
               tempImage.free;
          end;
     end;
end;


procedure CallbackFxn(CurDib: THandle; index: Integer); stdcall;
begin
     //   MessageBox(0, 'Called back!', 'CallbackFxn', mb_ok);
end;


end.

